/*****************************************************************************\
 *
 * scene_lights.cpp
 *
 * Algorithm for shadows ganeration in a scene
 * 
 *  Description: Class for handling lights in the scene
 *
 *      Authors: Tom Burian (xburia10 _AT stud.fit.vutbr.cz)
 *               
 *    Thanks to: PCJohn (peciva _AT fit.vutbr.cz)
 * 
 * Contributors:
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, authors will kindly welcome
 * if you give them credit and keep their names with their source code,
 * but do not feel to be forced to do so.
 *
\*****************************************************************************/

#include "scene_lights.h"
#include "shadows_win.h"

//----------------------------------------------------------------------------
// Constructor
//
SceneLights::SceneLights(SoSeparator * root)
 : sceneRootNode(root),
   lights(10),
   status(10)
{
  // todo?
}


//----------------------------------------------------------------------------
// Destructor; cleares both lists
// and dereferences lights
SceneLights::~SceneLights()
{
  for (int i=lights.getLength(); i >= 0 ; --i) {
    lights[i]->unref();
    status.remove(i);
    lights.remove(i);
  }
}


//----------------------------------------------------------------------------
// Adds a new light to the scene light manager
//
void SceneLights::addLight(SoLight * light)
{
  light->ref();
  lights.append(light);
  status.append(light->on.getValue());
  for (int e = 0; e < status.getLength(); e++) {
    SbBool s = status[e]; // use saved ligtht's status
  }

}


//----------------------------------------------------------------------------
// Removes and unrefs light
//
void SceneLights::removeLight(SoLight * light)
{  
  int i = 0;
  for (i = 0; i < lights.getLength(); i++) {
    if (light == lights[i]) break;
  }
  light->unref();
  lights.remove(i);
  status.remove(i);
}



//----------------------------------------------------------------------------
// TODO
//
void SceneLights::findLights(SoSeparator * root)
{

}


//----------------------------------------------------------------------------
// Sets all lights to its saved values
//
void SceneLights::lightsON()
{  
  for (int i = 0; i < lights.getLength(); i++) {
    lights[i]->on.enableNotify(FALSE);
    SbBool s = status[i]; // use saved ligtht's status
    lights[i]->on.setValue(s);
    lights[i]->on.enableNotify(TRUE);
  }
}


//----------------------------------------------------------------------------
// Turns OFF all lights 
//
void SceneLights::lightsOFF()
{  
  for (int i = 0; i < lights.getLength(); i++) {
    lights[i]->on.enableNotify(FALSE);
    SbBool s = lights[i]->on.getValue(); // save ligtht's status
    status[i] = s;
    lights[i]->on = false;
    lights[i]->on.enableNotify(TRUE);
  }
}
