/*****************************************************************************\
 *
 * scene_lights.h
 *
 * Algorithm for shadows ganeration in a scene
 * 
 *  Description: SceneLights class definition
 *
 *      Authors: Tom Burian (xburia10 _AT stud.fit.vutbr.cz)
 *               
 *    Thanks to: PCJohn (peciva _AT fit.vutbr.cz)
 * 
 * Contributors:
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, authors will kindly welcome
 * if you give them credit and keep their names with their source code,
 * but do not feel to be forced to do so.
 *
\*****************************************************************************/

#ifndef _SCENE_LIGHTS_H_
#define _SCENE_LIGHTS_H_


#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoLight.h>
#include <Inventor/nodes/SoCoordinate3.h>
#include <Inventor/nodes/SoNormal.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoTranslation.h>
#include <Inventor/nodes/SoIndexedTriangleStripSet.h>
#include <Inventor/nodes/SoTriangleStripSet.h>
#include <Inventor/nodes/SoShapeHints.h>
#include <Inventor/nodes/SoIndexedLineSet.h>
//
#include <Inventor/fields/SoSFVec3f.h>
#include <Inventor/fields/SoMFVec3f.h>
//
#include <Inventor/actions/SoSearchAction.h>
#include <Inventor/actions/SoGetMatrixAction.h>
#include <Inventor/actions/SoWriteAction.h>
//
#include <Inventor/SbLinear.h>
#include <Inventor/SoOutput.h>


#include <Inventor/lists/SbList.h> 
//----------------------------------------------------------------------------
// SceneLights class for managing lights in the scene
//
class SceneLights
{
  public:
    SbList<SoLight *> lights;       // list of all lights in the scene
    SbList<SbBool> status;          // ON / OFF light statuses list
    SoSeparator * sceneRootNode;    // root node of the scene

    void lightsON();
    void lightsOFF();

  public:
    SceneLights(SoSeparator * root);
    ~SceneLights();
    
    void addLight(SoLight * light);
    void removeLight(SoLight * light);
    void findLights(SoSeparator * root);

};

#endif
